## uncrustify 0.48

=== d/Makefile ===
#
# Simple D makefile
#
#

DCC=dmd
DCC_OPT=""
PROGRAM=uncrustify-d
SOURCES=main.d args.d log.d Logger.d LogMask.d LogSev.d settings.d options.d \
        TokenEnum.d TokenName.d

.default: $(PROGRAM)

$(PROGRAM): $(SOURCES)
	$(DCC) $^ -of$@

## uncrustify 0.56

=== debian/changelog ===
uncrustify (0.56-2) unstable; urgency=low

  [ Fathi Boudra ]
  * Added patch to check for NULL to prevent a segmentation fault.
    (Closes: #580195)
  * Bumped Standards-Version to 3.9.0 (no changes needed).

 -- Johann Rudloff <cypheon@gmx.net>  Thu, 01 Jul 2010 20:34:01 +0300

uncrustify (0.56-1) unstable; urgency=low

  * New upstream release.

  [ Fathi Boudra ]
  * Switch to dpkg-source 3.0 (quilt) format.
  * debian/control:
    - bumped debhelper version to 7.4.15
    - fixed typo in long description.
  * debian/copyright:
    - added email author.
    - added myself.

 -- Johann Rudloff <cypheon@gmx.net>  Tue, 20 Apr 2010 13:08:29 +0300

uncrustify (0.55-1) unstable; urgency=low

  * New upstream release (Closes: #540817)

  [ Fathi Boudra ]
  * debian/patches/manpage_fix_hyphens.diff: removed - merged upstream
  * debian/compat: bumped to 7
  * debian/control:
    - bumped debhelper version to 7.4.13
    - bumped Standards-Version to 3.8.4 (no changes needed)
    - added ${misc:Depends}
  * debian/docs: updated
  * debian/rules: rewrited from scratch to use dh and enabled parallel build

 -- Johann Rudloff <cypheon@gmx.net>  Wed, 17 Feb 2010 09:18:41 +0100

uncrustify (0.52-1) unstable; urgency=low

  * New upstream release (closes: #526100)
  * debian/copyright: changed years and wording of copyright
  * debian/patches/manpage_fix_hyphens.diff: added patch to fix fixed hyphens
    used as minus signs in manpage
  * debian/rules: included usage of quilt
  * debian/control: added build dependency quilt
    bumped Standards-Version to 3.8.1 (no changes required)

 -- Johann Rudloff <cypheon@gmx.net>  Thu, 30 Apr 2009 11:32:27 +0200

uncrustify (0.48-1) unstable; urgency=low

  * New upstream release
  * debian/rules: removed CFLAGS settings (done by dpkg-buildpackage)

 -- Johann Rudloff <cypheon@gmx.net>  Tue, 22 Jul 2008 11:19:54 +0200

uncrustify (0.47-1) unstable; urgency=low

  * New upstream release (closes: #479372)
  * Bumped Standards-Version to 3.8.0 (no changes required)
  * removed debian/uncrustify.1, since upstream sources now include a
    manpage
  * debian/rules: removed call to dh_installman, manpage is installed by
    make install
  * debian/rules: removed unneeded call to dh_installdirs

 -- Johann Rudloff <cypheon@gmx.net>  Sun, 08 Jun 2008 10:09:53 +0200

uncrustify (0.44-1) unstable; urgency=low

  * New upstream release
  * debian/uncrustify.1: updated version number and date

 -- Johann Rudloff <cypheon@gmx.net>  Sun, 24 Feb 2008 09:13:49 +0100

uncrustify (0.43-1) unstable; urgency=low

  * New upstream release (closes: #461631)
  * Bumped Standards-Version to 3.7.3 (no changes required)
  * debian/copyright: updated years of copyright
  * debian/control: moved homepage address from description to a separate field
  * debian/uncrustify.1: updated year and month
  * debian/rules: copy update config.{sub,guess} into source tree in
    config.status target, remove them in clean target

 -- Johann Rudloff <cypheon@gmx.net>  Thu, 10 Jan 2008 15:37:19 +0100

uncrustify (0.41-1) unstable; urgency=low

  * New upstream release

 -- Johann Rudloff <cypheon@gmx.net>  Mon, 12 Nov 2007 21:22:25 +0100

uncrustify (0.40-1) unstable; urgency=low

  * New upstream release

 -- Johann Rudloff <cypheon@gmx.net>  Tue, 16 Oct 2007 21:26:13 +0200

uncrustify (0.39-1) unstable; urgency=low

  * New Upstream Version

 -- Johann Rudloff <cypheon@gmx.net>  Wed, 26 Sep 2007 23:50:30 +0200

uncrustify (0.38-1) unstable; urgency=low

  * New upstream release

 -- Johann Rudloff <cypheon@gmx.net>  Thu, 06 Sep 2007 22:52:16 +0200

uncrustify (0.37-1) unstable; urgency=low

  * New upstream release
  * debian/uncrustify.1: added new command line options
  * debian/uncrustify.1: changes in formatting and description

 -- Johann Rudloff <cypheon@gmx.net>  Sun, 19 Aug 2007 19:33:08 +0200

uncrustify (0.36-1) unstable; urgency=low

  * New upstream release (closes: #434938, #434939)

 -- Johann Rudloff <cypheon@gmx.net>  Tue, 07 Aug 2007 13:49:41 +0200

uncrustify (0.35-1) unstable; urgency=low

  * New upstream release

 -- Johann Rudloff <cypheon@gmx.net>  Sat, 21 Jul 2007 20:41:52 +0200

uncrustify (0.33-1) unstable; urgency=low

  * New upstream release (closes: #416469)
  * Added debian/watch file
  * debian/uncrustify.1: added new command line options
  * debian/uncrustify.1: removed leading colons
  * debian/copyright: updated years of copyright
  * debian/copyright: updated parts concerning cmpcfg.pl, since it
    now contains a proper license statement

 -- Johann Rudloff <cypheon@gmx.net>  Fri, 30 Mar 2007 20:51:27 +0200

uncrustify (0.30-1) unstable; urgency=low

  * Initial release

 -- Johann Rudloff <cypheon@gmx.net>  Sat, 25 Nov 2006 14:06:44 +0100

=== debian/control ===
Source: uncrustify
Section: devel
Priority: optional
Maintainer: Johann Rudloff <cypheon@gmx.net>
Build-Depends: debhelper (>= 7.4.15), autotools-dev
Standards-Version: 3.9.0
Homepage: http://uncrustify.sourceforge.net/

Package: uncrustify
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C, C++, C#, D, Java and Pawn source code beautifier
 Uncrustify is a highly configurable source code formatter. It aligns
 preprocessor define's, assignments, arithmetics and is able to fix spacing
 between operators.

## uncrustify 0.57

=== debian/changelog ===
uncrustify (0.57-1) unstable; urgency=low

  * New upstream release.

  [ Fathi Boudra ]
  * Removed patch to check for NULL - stolen upstream.
  * Bumped Standards-Version to 3.9.1 (no changes needed).

 -- Johann Rudloff <cypheon@gmx.net>  Mon, 21 Feb 2011 11:54:28 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: devel
 Priority: optional
 Maintainer: Johann Rudloff <cypheon@gmx.net>
-Build-Depends: debhelper (>= 7.4.15), autotools-dev
-Standards-Version: 3.9.0
+Build-Depends: debhelper (>= 8.0.0), autotools-dev
+Standards-Version: 3.9.1
 Homepage: http://uncrustify.sourceforge.net/
 
 Package: uncrustify

## uncrustify 0.59

=== debian/changelog ===
uncrustify (0.59-2) unstable; urgency=low

  * Fix FTBFS with gcc 4.7 by fixing missing <unistd.h> include.
    (Closes: #667404)

 -- Fathi Boudra <fabo@debian.org>  Mon, 21 May 2012 15:40:46 +0300

uncrustify (0.59-1) unstable; urgency=low

  * New upstream release.
  * Add myself to Uploaders.

 -- Fathi Boudra <fabo@debian.org>  Sat, 31 Dec 2011 12:49:32 +0200

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --parallel

.PHONY: override_dh_auto_test

=== debian/watch ===
version=3
http://sf.net/uncrustify/ uncrustify-(.*)\.tgz

## uncrustify 0.59+dfsg1

=== debian/changelog ===
uncrustify (0.59+dfsg1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove non-free file (project-support.jpg). Closes: #753760

 -- Mathieu Malaterre <malat@debian.org>  Fri, 16 Jan 2015 16:52:15 +0100

=== debian/control ===
Source: uncrustify
Section: devel
Priority: optional
Maintainer: Johann Rudloff <cypheon@gmx.net>
Uploaders: Fathi Boudra <fabo@debian.org>
Build-Depends: autotools-dev, debhelper (>= 8)
Standards-Version: 3.9.3
Homepage: http://uncrustify.sourceforge.net/

Package: uncrustify
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C, C++, C#, D, Java and Pawn source code beautifier
 Uncrustify is a highly configurable source code formatter. It aligns
 preprocessor define's, assignments, arithmetics and is able to fix spacing
 between operators.

## uncrustify 0.64+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(uncrustify)

if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(FATAL_ERROR "
    In-source builds are not supported, please remove the `CMakeFiles'
    folder and `CMakeCache.txt', and create a folder for the build:
    mkdir build; cd build; cmake ..
  ")
endif()

include(CheckCXXCompilerFlag)
include(CheckIncludeFileCXX)
include(CheckSymbolExists)
include(CheckCXXSymbolExists)
include(CheckTypeSize)
include(CTest)

#
# Check compiler flags
#
if(MSVC)
  add_definitions(/D_CRT_SECURE_NO_WARNINGS /D_CRT_NONSTDC_NO_WARNINGS /wd4267)
elseif(CMAKE_COMPILER_IS_GNUCXX)
  set(gcc_warning_flags
    -Wall
    -Wextra
    -Wshadow
    -Wpointer-arith
    -Wcast-qual
    -Wcast-align
  )
  foreach(flag ${gcc_warning_flags})
    string(REGEX REPLACE "[^a-zA-Z0-9]+" "_" flag_var "CXXFLAG_${flag}")
    CHECK_CXX_COMPILER_FLAG("${flag}" ${flag_var})
    if(${flag_var})
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
    endif()
    unset(flag_var)
  endforeach()
  unset(gcc_warning_flags)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif()

if(ENABLE_SANITIZER)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1 -fno-omit-frame-pointer -fsanitize=${ENABLE_SANITIZER}")
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR})

#
# Determine config
#
if(WIN32)
  # Windows builds use src/windows_compat.h instead of config.h
else()
  # Generate config.h
  set(avail_headers "")

  set(headers
    inttypes.h
    memory.h
    stdint.h
    stdlib.h
    strings.h
    string.h
    sys/stat.h
    sys/types.h
    unistd.h
    utime.h
  )
  foreach(header ${headers})
    string(TOUPPER "${header}" header_uc)
    string(REGEX REPLACE "[^A-Z0-9_]" "_" include_var "HAVE_${header_uc}")
    check_include_file_cxx("${header}" ${include_var})
    if(${include_var})
      list(APPEND avail_headers ${header})
    endif()
    unset(include_var)
    unset(header_uc)
  endforeach()
  unset(headers)

  check_include_file("stdbool.h" HAVE_STDBOOL_H)

  set(symbols
    memset
    strcasecmp
    strchr
    strdup
    strerror
    strtol
    strtoul
  )
  foreach(symbol ${symbols})
    string(TOUPPER "${symbol}" symbol_uc)
    string(REGEX REPLACE "[^A-Z0-9_]" "_" symbol_var "HAVE_${symbol_uc}")
    check_cxx_symbol_exists("${symbol}" "${avail_headers}" ${symbol_var})
    unset(symbol_var)
    unset(symbol_uc)
  endforeach()
  unset(symbols)

  unset(avail_headers)

  check_type_size(_Bool _BOOL LANGUAGE C)

  configure_file(src/config.h.in config.h @ONLY)
endif()

#
# Generate uncrustify_version.h
#
set(PACKAGE_VERSION "0.64")

if (MAKE_VERSION)
  find_package(PythonInterp REQUIRED)
  execute_process(
    COMMAND ${PYTHON_EXECUTABLE} scripts/make_version.py
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    RESULT_VARIABLE make_version_error
    OUTPUT_VARIABLE make_version_output
  )

  if (make_version_error)
    message(WARNING ${make_version_output})
  else()
    if (${make_version_output} MATCHES "full version: (.*)\n tag version: (.*)")
      set(full_version ${CMAKE_MATCH_1})
      set(tag_version ${CMAKE_MATCH_2})
      message(STATUS "Uncrustify full version: ${full_version}")
      message(STATUS "Uncrustify  tag version: ${tag_version}")
    endif()
    set(PACKAGE_VERSION "${full_version}")
  endif()
endif()

configure_file(src/uncrustify_version.h.in uncrustify_version.h @ONLY)

#
# Generate token_names.h
#
add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/token_names.h"
  COMMAND ${CMAKE_COMMAND}
    "-Dsrc_file=${PROJECT_SOURCE_DIR}/src/token_enum.h"
    "-Ddst_file=${CMAKE_CURRENT_BINARY_DIR}/token_names.h"
    -P "${PROJECT_SOURCE_DIR}/cmake/GenerateTokenNames.cmake"
  MAIN_DEPENDENCY src/token_enum.h
  COMMENT "Generating token_names.h"
)

#
# Uncrustify
#
add_executable(uncrustify
  src/align.cpp
  src/align_stack.cpp
  src/args.cpp
  src/backup.cpp
  src/braces.cpp
  src/brace_cleanup.cpp
  src/ChunkStack.cpp
  src/chunk_list.cpp
  src/combine.cpp
  src/compat_posix.cpp
  src/compat_win32.cpp
  src/defines.cpp
  src/detect.cpp
  src/indent.cpp
  src/keywords.cpp
  src/lang_pawn.cpp
  src/logger.cpp
  src/logmask.cpp
  src/md5.cpp
  src/newlines.cpp
  src/options.cpp
  src/options_for_QT.cpp
  src/output.cpp
  src/parens.cpp
  src/parse_frame.cpp
  src/punctuators.cpp
  src/semicolons.cpp
  src/sorting.cpp
  src/space.cpp
  src/tokenize.cpp
  src/tokenize_cleanup.cpp
  src/uncrustify.cpp
  src/unc_text.cpp
  src/unc_tools.cpp
  src/unicode.cpp
  src/universalindentgui.cpp
  src/width.cpp
  src/align_stack.h
  src/args.h
  src/backup.h
  src/base_types.h
  src/char_table.h
  src/ChunkStack.h
  src/chunk_list.h
  src/ListManager.h
  src/logger.h
  src/logmask.h
  src/log_levels.h
  src/md5.h
  src/options.h
  src/options_for_QT.h
  src/prototypes.h
  src/punctuators.h
  src/token_enum.h
  src/uncrustify_types.h
  src/unc_ctype.h
  src/unc_text.h
  src/unc_tools.h
)

if(CMAKE_VERSION VERSION_LESS 2.8.10)
  if(CMAKE_CONFIGURATION_TYPES OR CMAKE_BUILD_TYPE)
    # Multi-configuration or build type set
    set_property(TARGET uncrustify APPEND PROPERTY
      COMPILE_DEFINITIONS_DEBUG DEBUG
    )
  else()
    # Single-configuration with no build type set
    set_property(TARGET uncrustify APPEND PROPERTY
      COMPILE_DEFINITIONS DEBUG
    )
  endif()
else()
  set_property(TARGET uncrustify APPEND PROPERTY
    COMPILE_DEFINITIONS $<$<OR:$<CONFIG:Debug>,$<CONFIG:>>:DEBUG>
  )
endif()

#
# Generate uncrustify.1
#
configure_file(man/uncrustify.1.in uncrustify.1 @ONLY)

#
# Tests
#
if(BUILD_TESTING)
  enable_testing()
  add_subdirectory(tests)
endif()

#
# Package
#
set(CPACK_PACKAGE_NAME "uncrustify")
set(CPACK_PACKAGE_VERSION "${PACKAGE_VERSION}")
set(CPACK_PACKAGE_VENDOR "Ben Gardner")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Code beautifier")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_SOURCE_IGNORE_FILES "/\\\\.git/;/\\\\.hg/;/tests/results/;/build.*/")
if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY FALSE)
  set(CPACK_GENERATOR "ZIP")
endif()
include(CPack)

#
# Install
#
if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  install(TARGETS uncrustify DESTINATION ".")
  install(
    FILES
      "${PROJECT_SOURCE_DIR}/README.md"
      "${PROJECT_SOURCE_DIR}/BUGS"
      "${PROJECT_SOURCE_DIR}/ChangeLog"
    DESTINATION "."
  )
  install(FILES "${PROJECT_SOURCE_DIR}/documentation/htdocs/index.html"
    DESTINATION "doc"
  )
  install(DIRECTORY "${PROJECT_SOURCE_DIR}/etc/"
    DESTINATION "cfg"
    FILES_MATCHING PATTERN "*.cfg"
  )
else()
  include(GNUInstallDirs)
  install(TARGETS uncrustify
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
  )
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/uncrustify.1"
    DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
  )
endif()

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

function(add_uncrustify_test name lang config rerun_config input result output)
  add_test(NAME ${name}
    COMMAND ${CMAKE_COMMAND}
      -DTEST_PROGRAM=$<TARGET_FILE:uncrustify>
      -DTEST_LANG=${lang}
      -DTEST_CONFIG=${config}
      -DTEST_RERUN_CONFIG=${rerun_config}
      -DTEST_INPUT=${input}
      -DTEST_RESULT=${result}
      -DTEST_OUTPUT=${output}
      -DTEST_DIR=${PROJECT_SOURCE_DIR}/tests
      -P ${PROJECT_SOURCE_DIR}/tests/run_test.cmake
  )
  set_tests_properties(${name}
    PROPERTIES LABELS "${lang}"
  )
endfunction()

foreach(test_lang c-sharp c cpp d java pawn objective-c vala ecma)
  file(READ "${test_lang}.test" content)
  string(REPLACE "\n" ";" lines "${content}")
  foreach(line ${lines})
    string(STRIP "${line}" line)
    string(SUBSTRING "${line}" 0 1 first)
    # trailing space avoids double evaluation with older CMake versions
    if(NOT "${first} " STREQUAL "# ")
      if("${line}" MATCHES "^([0-9]+)([!]?)[ ]+([^ ]+)[ ]+([^ ]+)$")
        set(test_number "${CMAKE_MATCH_1}")
        set(test_name "${test_number}")

        set(test_config config/${CMAKE_MATCH_3})
        set(test_input input/${CMAKE_MATCH_4})

        get_filename_component(test_dir ${CMAKE_MATCH_4} PATH)
        get_filename_component(test_file ${CMAKE_MATCH_4} NAME)

        set(test_expected ${test_dir}/${CMAKE_MATCH_1}-${test_file})
        set(test_output output/${test_expected})
        set(test_result results/${test_expected})

        if("${CMAKE_MATCH_2} " STREQUAL "! ")
          string(REGEX REPLACE "\\.[^.]*" ".rerun.cfg" test_rerun_config ${test_config})
        else()
          set(test_rerun_config ${test_config})
        endif()

        add_uncrustify_test(${test_name} ${test_dir} ${test_config} ${test_rerun_config}
          ${test_input} ${test_result} ${test_output})

      endif()
    endif()
  endforeach()
endforeach()

=== debian/changelog ===
uncrustify (0.64+dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 0.64
    (Closes:  #748787, #814193, #594210, #775517, #594206, #616708)
  * Remove non-free documentation/htdocs/project-support.jpg.
  * Imported debian dir from previous version.
  * Remove "debian/<q" file.
  * Remove fix-ftbfs-with-gcc-4.7.patch (Fixed upstream).
  * debian/control: Switch dependence from autotools to cmake.
  * debian/control, debian/compat: Set compatibility level to 9.
  * debian/rules: Remove legacy PRONY records.
  * debian/control: Change Homepage to github.
  * debian/watch: Update to github using current naming scheme.
  * debian/copyright: Add myself.
  * Install README.md and documentation dir into package's docs.
  * debian/rules: Remove tests results on clean.
  * debian/control: Set myself as maintainer. (Johann Rudloff is out of
    business, thanks a lot for all; Fathi Boudra acked this.)
  * Bump Standards-Version to 3.9.8 (no additional changes needed).
  * Add debian/TODO file.
  * debian/cotrol: Add link to collab-maint's git.

 -- Alexander GQ Gerasiov <gq@debian.org>  Sat, 03 Dec 2016 20:19:22 +0300

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,13 @@
 Source: uncrustify
 Section: devel
 Priority: optional
-Maintainer: Johann Rudloff <cypheon@gmx.net>
+Maintainer: Alexander GQ Gerasiov <gq@debian.org>
 Uploaders: Fathi Boudra <fabo@debian.org>
-Build-Depends: autotools-dev, debhelper (>= 8)
-Standards-Version: 3.9.3
-Homepage: http://uncrustify.sourceforge.net/
+Build-Depends: debhelper (>= 9), cmake
+Standards-Version: 3.9.8
+Homepage: https://github.com/uncrustify/uncrustify
+Vcs-Git: git://anonscm.debian.org/collab-maint/uncrustify.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/uncrustify.git;a=summary
 
 Package: uncrustify
 Architecture: any

## uncrustify 0.65+git20170831+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
 if(MSVC)
   add_definitions(/D_CRT_SECURE_NO_WARNINGS /D_CRT_NONSTDC_NO_WARNINGS /wd4267)
 elseif(CMAKE_COMPILER_IS_GNUCXX)
+  add_definitions(-std=gnu++0x)
   set(gcc_warning_flags
     -Wall
     -Wextra
@@ -30,6 +31,7 @@
     -Wpointer-arith
     -Wcast-qual
     -Wcast-align
+    -Wc++11-extensions
   )
   foreach(flag ${gcc_warning_flags})
     string(REGEX REPLACE "[^a-zA-Z0-9]+" "_" flag_var "CXXFLAG_${flag}")
@@ -41,6 +43,7 @@
   endforeach()
   unset(gcc_warning_flags)
 elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+  add_definitions(-std=gnu++0x)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
 endif()
 
@@ -113,28 +116,37 @@
 #
 # Generate uncrustify_version.h
 #
-set(PACKAGE_VERSION "0.64")
-
-if (MAKE_VERSION)
-  find_package(PythonInterp REQUIRED)
-  execute_process(
-    COMMAND ${PYTHON_EXECUTABLE} scripts/make_version.py
-    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
-    RESULT_VARIABLE make_version_error
-    OUTPUT_VARIABLE make_version_output
-  )
-
-  if (make_version_error)
-    message(WARNING ${make_version_output})
-  else()
-    if (${make_version_output} MATCHES "full version: (.*)\n tag version: (.*)")
-      set(full_version ${CMAKE_MATCH_1})
-      set(tag_version ${CMAKE_MATCH_2})
-      message(STATUS "Uncrustify full version: ${full_version}")
-      message(STATUS "Uncrustify  tag version: ${tag_version}")
+
+# FIXME: the version number should be automatically integrated
+set(CURRENT_VERSION "Uncrustify-0.65_f")
+
+option(NoGitVersionString "Do not use make_version.py and git to build a version string" OFF)
+if(NOT NoGitVersionString)
+    find_package(PythonInterp)
+    if(PythonInterp_FOUND)
+        set(version_debug_flag "")
+        STRING(REGEX MATCH "-g[0-3]?" version_debug_flag ${CMAKE_CXX_FLAGS})
+
+        # checking for build type and passing it to make_version.py
+        # FIXME: does not work with VS .sln projects
+        if(NOT "${version_debug_flag}" STREQUAL "" OR "${CMAKE_BUILD_TYPE}" STREQUAL "Debug" )
+            set(version_debug_flag "Debug")
+        endif()
+
+        execute_process(
+            COMMAND ${PYTHON_EXECUTABLE} scripts/make_version.py ${version_debug_flag}
+            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
+            RESULT_VARIABLE make_version_error
+            OUTPUT_VARIABLE make_version_output
+        )
+
+        if (make_version_error)
+            message(STATUS "scripts/make_version.py exited with code ${make_version_error}: ${make_version_output}\n"
+                           "As a fallback, version '${CURRENT_VERSION}' will be used.")
+        else()
+            string(STRIP ${make_version_output} CURRENT_VERSION)
+        endif()
     endif()
-    set(PACKAGE_VERSION "${full_version}")
-  endif()
 endif()
 
 configure_file(src/uncrustify_version.h.in uncrustify_version.h @ONLY)
@@ -169,6 +181,7 @@
   src/compat_win32.cpp
   src/defines.cpp
   src/detect.cpp
+  src/helper_for_print.cpp
   src/indent.cpp
   src/keywords.cpp
   src/lang_pawn.cpp
@@ -200,6 +213,7 @@
   src/char_table.h
   src/ChunkStack.h
   src/chunk_list.h
+  src/helper_for_print.h
   src/ListManager.h
   src/logger.h
   src/logmask.h
@@ -251,7 +265,7 @@
 # Package
 #
 set(CPACK_PACKAGE_NAME "uncrustify")
-set(CPACK_PACKAGE_VERSION "${PACKAGE_VERSION}")
+set(CPACK_PACKAGE_VERSION "${CURRENT_VERSION}")
 set(CPACK_PACKAGE_VENDOR "Ben Gardner")
 set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Code beautifier")
 set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
@@ -292,3 +306,8 @@
     DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
   )
 endif()
+
+#
+# add to build the compile_commands.json file, to be used by clang-tidy
+#
+set(CMAKE_EXPORT_COMPILE_COMMANDS "ON" CACHE BOOL "to create the compile_commands.json file" FORCE)

=== debian/changelog ===
uncrustify (0.65+git20170831+dfsg1-1) unstable; urgency=medium

  * New upstream version 0.65+git20170831 (Closes: #867376)
  * Bump Standards-Version to 4.1.0 (no additional changes needed).

 -- Alexander GQ Gerasiov <gq@debian.org>  Thu, 31 Aug 2017 20:25:06 +0300

uncrustify (0.65+dfsg1-1) unstable; urgency=medium

  * New upstream version 0.65
  * debian/control: Add python-minimal to Build-Depends.

 -- Alexander GQ Gerasiov <gq@debian.org>  Tue, 04 Jul 2017 14:50:47 +0300

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Alexander GQ Gerasiov <gq@debian.org>
 Uploaders: Fathi Boudra <fabo@debian.org>
-Build-Depends: debhelper (>= 9), cmake
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 9), cmake, python-minimal
+Standards-Version: 4.1.0
 Homepage: https://github.com/uncrustify/uncrustify
 Vcs-Git: git://anonscm.debian.org/collab-maint/uncrustify.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/uncrustify.git;a=summary

## uncrustify 0.66.1%2Bdfsg1

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,9 @@
   )
 endfunction()
 
-foreach(test_lang c-sharp c cpp d java pawn objective-c vala ecma)
+foreach(test_lang c-sharp c cpp d java pawn objective-c vala ecma imported)
+  # Create dependency on test file so CMake re-runs if changed
+  configure_file("${test_lang}.test" "${test_lang}.test" COPYONLY)
   file(READ "${test_lang}.test" content)
   string(REPLACE "\n" ";" lines "${content}")
   foreach(line ${lines})
@@ -28,7 +30,7 @@
     if(NOT "${first} " STREQUAL "# ")
       if("${line}" MATCHES "^([0-9]+)([!]?)[ ]+([^ ]+)[ ]+([^ ]+)$")
         set(test_number "${CMAKE_MATCH_1}")
-        set(test_name "${test_number}")
+        set(test_name "${test_lang}_${test_number}")
 
         set(test_config config/${CMAKE_MATCH_3})
         set(test_input input/${CMAKE_MATCH_4})

## uncrustify 0.66.1+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,9 @@
     endif()
     unset(flag_var)
   endforeach()
+  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers")
+  endif()
   unset(gcc_warning_flags)
 elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   add_definitions(-std=gnu++0x)
@@ -118,7 +121,7 @@
 #
 
 # FIXME: the version number should be automatically integrated
-set(CURRENT_VERSION "Uncrustify-0.65_f")
+set(CURRENT_VERSION "Uncrustify-0.66.1_f")
 
 option(NoGitVersionString "Do not use make_version.py and git to build a version string" OFF)
 if(NOT NoGitVersionString)
@@ -205,6 +208,7 @@
   src/unc_tools.cpp
   src/unicode.cpp
   src/universalindentgui.cpp
+  src/controlPSECount.cpp
   src/width.cpp
   src/align_stack.h
   src/args.h
@@ -228,6 +232,7 @@
   src/unc_ctype.h
   src/unc_text.h
   src/unc_tools.h
+  src/controlPSECount.h
 )
 
 if(CMAKE_VERSION VERSION_LESS 2.8.10)

=== emscripten/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

# ------------------------------------------------------------------------------

SET(emscripten_root_path "$ENV{EMSCRIPTEN}")

# Abort if not found.
if ("${emscripten_root_path}" STREQUAL "")
  MESSAGE(FATAL_ERROR "Could not locate the Emscripten directory via the \
                       EMSCRIPTEN environment variable! Set it up or pass \
                       -Demscripten_root_path=xxx to CMake to specify the \
                       directory.")
endif()

SET(CMAKE_TOOLCHAIN_FILE "${emscripten_root_path}/cmake/Modules/Platform/Emscripten.cmake")

SET(project_name "libUncrustify")
PROJECT(${project_name})

set(CMAKE_INCLUDE_CURRENT_DIR ON)

#get parent folder, add src
GET_FILENAME_COMPONENT(unc_projdir ${CMAKE_CURRENT_LIST_DIR} DIRECTORY)

# ------------------------------------------------------------------------------

include(CheckCXXCompilerFlag)
include(CheckIncludeFileCXX)
include(CheckSymbolExists)
include(CheckCXXSymbolExists)
include(CheckTypeSize)

#
# Determine config
#
if(WIN32)
  # Windows builds use src/windows_compat.h instead of config.h
else()
  # Generate config.h
  set(avail_headers "")

  set(headers
    inttypes.h
    memory.h
    stdint.h
    stdlib.h
    strings.h
    string.h
    sys/stat.h
    sys/types.h
    unistd.h
    utime.h
  )
  foreach(header ${headers})
    string(TOUPPER "${header}" header_uc)
    string(REGEX REPLACE "[^A-Z0-9_]" "_" include_var "HAVE_${header_uc}")
    check_include_file_cxx("${header}" ${include_var})
    if(${include_var})
      list(APPEND avail_headers ${header})
    endif()
    unset(include_var)
    unset(header_uc)
  endforeach()
  unset(headers)

  check_include_file("stdbool.h" HAVE_STDBOOL_H)

  set(symbols
    memset
    strcasecmp
    strchr
    strdup
    strerror
    strtol
    strtoul
  )
  foreach(symbol ${symbols})
    string(TOUPPER "${symbol}" symbol_uc)
    string(REGEX REPLACE "[^A-Z0-9_]" "_" symbol_var "HAVE_${symbol_uc}")
    check_cxx_symbol_exists("${symbol}" "${avail_headers}" ${symbol_var})
    unset(symbol_var)
    unset(symbol_uc)
  endforeach()
  unset(symbols)

  unset(avail_headers)

  check_type_size(_Bool _BOOL LANGUAGE C)

  configure_file("${unc_projdir}/src/config.h.in" config.h @ONLY)
endif()


#
# Generate uncrustify_version.h
#

# FIXME: checking for CMAKE_BUILD_TYPE and passing it to make_version.py
# does not work with VS .sln projects
if( NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release )
endif()
set( FALLBACK_VERSION "Uncrustify-0.64_f" )

find_package(PythonInterp REQUIRED)
execute_process(
  COMMAND ${PYTHON_EXECUTABLE} "${unc_projdir}/scripts/make_version.py" ${CMAKE_BUILD_TYPE}
  WORKING_DIRECTORY ${unc_projdir}
  RESULT_VARIABLE make_version_error
  OUTPUT_VARIABLE make_version_output
)

if (make_version_error)
    message(WARNING "${make_version_error}: ${make_version_output}, ../scripts/make_version.py doesn't work properly")
    set( CURRENT_VERSION ${FALLBACK_VERSION} )
else()
    string(STRIP ${make_version_output} CURRENT_VERSION)
endif()

configure_file("${unc_projdir}/src/uncrustify_version.h.in" uncrustify_version.h @ONLY)


#
# Generate token_names.h
#
add_custom_command(
  OUTPUT "token_names.h"
  COMMAND ${CMAKE_COMMAND}
    "-Dsrc_file=${unc_projdir}/src/token_enum.h"
    "-Ddst_file=token_names.h"
    -P "${unc_projdir}/cmake/GenerateTokenNames.cmake"
  MAIN_DEPENDENCY "${unc_projdir}/src/token_enum.h"
  COMMENT "Generating token_names.h"
)

# ------------------------------------------------------------------------------

FILE(GLOB unc_infiles "${unc_projdir}/src/*.cpp")

ADD_EXECUTABLE(${project_name} ${unc_infiles} ${unc_projdir}/src/token_enum.h)

SET(unc_compile_flags "--bind -O3")
SET_TARGET_PROPERTIES(${project_name}
    PROPERTIES
        COMPILE_FLAGS "${unc_compile_flags}"
        LINK_FLAGS "${unc_compile_flags} \
                    -s TOTAL_MEMORY=67108864 \
                    -s ALLOW_MEMORY_GROWTH=1 \
                    -s VERBOSE=1 \
                    -s MODULARIZE=1 \
                    -s EXPORT_NAME=\"'${project_name}'\" \
                    -s ERROR_ON_UNDEFINED_SYMBOLS=1 \
                    --memory-init-file 0\
                    --pre-js ${CMAKE_CURRENT_LIST_DIR}/prefix_module.js \
                    --post-js ${CMAKE_CURRENT_LIST_DIR}/postfix_module.js \
                    ")

EM_LINK_PRE_JS(${project_name} ${CMAKE_CURRENT_LIST_DIR}/prefix_module.js)
EM_LINK_POST_JS(${project_name} ${CMAKE_CURRENT_LIST_DIR}/postfix_module.js)

# ------------------------------------------------------------------------------

# add file post/pre-fix
add_custom_command(TARGET ${project_name}
                   POST_BUILD
                   COMMAND ${CMAKE_COMMAND} -Dunc_targetfile:FILEPATH=$<TARGET_FILE:${project_name}>
                                            -P "${CMAKE_CURRENT_LIST_DIR}/CMake_catFiles.cmake"
)

add_custom_target(emscripten_test
    COMMAND ${CMAKE_COMMAND} -Dunc_targetfile:FILEPATH=$<TARGET_FILE:${project_name}>
                             -Dunc_projdir:FILEPATH=${unc_projdir}
                             -P "${CMAKE_CURRENT_LIST_DIR}/CMake_emscripten_test.cmake"
    COMMENT "Starting libUncrustify.js tests:"
)

=== debian/changelog ===
uncrustify (0.66.1+dfsg1-1) unstable; urgency=medium

  * Add debian/gbp.conf.
  * New upstream version 0.66.1 Fixed FTBFS on some arches (Closes: #881249)
  * Bump Standards-Version to 4.1.2 (no additional changes needed).

 -- Alexander GQ Gerasiov <gq@debian.org>  Sun, 17 Dec 2017 18:49:06 +0300

uncrustify (0.66+dfsg1-1) unstable; urgency=medium

  * debian/control: Remove Fathi Boudra <fabo@debian.org> from uploaders.
    (Closes: #879444.) Thanks for your job.
  * New upstream version 0.66
  * Bump Standards-Version to 4.1.1 (no additional changes needed).
  * debian/control: Add more languages to short description.

 -- Alexander GQ Gerasiov <gq@debian.org>  Wed, 08 Nov 2017 18:18:47 +0300

=== debian/control ===
Source: uncrustify
Section: devel
Priority: optional
Maintainer: Alexander GQ Gerasiov <gq@debian.org>
Build-Depends: debhelper (>= 9), cmake, python-minimal
Standards-Version: 4.1.2
Homepage: https://github.com/uncrustify/uncrustify
Vcs-Git: git://anonscm.debian.org/collab-maint/uncrustify.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/uncrustify.git;a=summary

Package: uncrustify
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C, C++, ObjectiveC, C#, D, Java, Pawn and VALA source code beautifier
 Uncrustify is a highly configurable source code formatter. It aligns
 preprocessor define's, assignments, arithmetics and is able to fix spacing
 between operators.

=== debian/rules ===
--- 
+++ 
@@ -6,4 +6,6 @@
 %:
 	dh $@ --parallel
 
-.PHONY: override_dh_auto_test
+override_dh_clean:
+	dh_clean
+	rm -rf tests/results

## uncrustify 0.68.1+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,7 @@
 #
 if(MSVC)
   add_definitions(/D_CRT_SECURE_NO_WARNINGS /D_CRT_NONSTDC_NO_WARNINGS /wd4267)
+  add_definitions(/utf-8)
 elseif(CMAKE_COMPILER_IS_GNUCXX)
   add_definitions(-std=gnu++0x)
   set(gcc_warning_flags
@@ -54,7 +55,11 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1 -fno-omit-frame-pointer -fsanitize=${ENABLE_SANITIZER}")
 endif()
 
-include_directories(${CMAKE_CURRENT_BINARY_DIR})
+include_directories(
+  ${PROJECT_BINARY_DIR}/src
+  ${PROJECT_SOURCE_DIR}/src
+  ${PROJECT_BINARY_DIR}
+)
 
 #
 # Determine config
@@ -121,35 +126,34 @@
 #
 
 # FIXME: the version number should be automatically integrated
-set(CURRENT_VERSION "Uncrustify-0.66.1_f")
-
+set(CURRENT_VERSION "Uncrustify-0.68_f")
+
+find_package(PythonInterp REQUIRED)
 option(NoGitVersionString "Do not use make_version.py and git to build a version string" OFF)
 if(NOT NoGitVersionString)
-    find_package(PythonInterp)
-    if(PythonInterp_FOUND)
-        set(version_debug_flag "")
-        STRING(REGEX MATCH "-g[0-3]?" version_debug_flag ${CMAKE_CXX_FLAGS})
-
-        # checking for build type and passing it to make_version.py
-        # FIXME: does not work with VS .sln projects
-        if(NOT "${version_debug_flag}" STREQUAL "" OR "${CMAKE_BUILD_TYPE}" STREQUAL "Debug" )
-            set(version_debug_flag "Debug")
-        endif()
-
-        execute_process(
-            COMMAND ${PYTHON_EXECUTABLE} scripts/make_version.py ${version_debug_flag}
-            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
-            RESULT_VARIABLE make_version_error
-            OUTPUT_VARIABLE make_version_output
-        )
-
-        if (make_version_error)
-            message(STATUS "scripts/make_version.py exited with code ${make_version_error}: ${make_version_output}\n"
-                           "As a fallback, version '${CURRENT_VERSION}' will be used.")
-        else()
-            string(STRIP ${make_version_output} CURRENT_VERSION)
-        endif()
-    endif()
+  set(version_debug_flag "")
+  STRING(REGEX MATCH "-g[0-3]?" version_debug_flag ${CMAKE_CXX_FLAGS})
+
+  # checking for build type and passing it to make_version.py
+  # FIXME: does not work with VS .sln projects
+  if(NOT "${version_debug_flag}" STREQUAL "" OR "${CMAKE_BUILD_TYPE}" STREQUAL "Debug" )
+    set(version_debug_flag "Debug")
+  endif()
+
+  execute_process(
+    COMMAND ${PYTHON_EXECUTABLE} scripts/make_version.py ${version_debug_flag}
+    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
+    RESULT_VARIABLE make_version_error
+    OUTPUT_VARIABLE make_version_output
+  )
+
+  if (make_version_error)
+    message(STATUS "scripts/make_version.py exited with code ${make_version_error}: ${make_version_output}\n"
+                   "As a fallback, version '${CURRENT_VERSION}' will be used.")
+  else()
+    string(STRIP ${make_version_output} CURRENT_VERSION)
+    message(STATUS "Version: '${CURRENT_VERSION}'")
+  endif()
 endif()
 
 configure_file(src/uncrustify_version.h.in uncrustify_version.h @ONLY)
@@ -167,10 +171,55 @@
   COMMENT "Generating token_names.h"
 )
 
+# Set up commands for generated source files
+function(py_gen OUTPUT SCRIPT INPUT)
+  set(out "${PROJECT_BINARY_DIR}/src/${OUTPUT}")
+  set(deps "${PROJECT_SOURCE_DIR}/src/${INPUT}")
+  get_filename_component(outdir "${out}" DIRECTORY)
+  foreach(arg IN LISTS ARGN)
+    list(APPEND deps "${PROJECT_SOURCE_DIR}/src/${arg}")
+  endforeach()
+
+  add_custom_command(
+    OUTPUT "${out}"
+    COMMAND ${CMAKE_COMMAND} -E make_directory "${outdir}"
+    COMMAND ${PYTHON_EXECUTABLE}
+      "${PROJECT_SOURCE_DIR}/scripts/${SCRIPT}"
+      "${out}"
+      ${deps}
+    DEPENDS ${deps} "${PROJECT_SOURCE_DIR}/scripts/${SCRIPT}"
+    MAIN_DEPENDENCY src/${INPUT}
+    COMMENT "Generating ${OUTPUT}"
+  )
+endfunction()
+
+py_gen(punctuator_table.h
+  make_punctuator_table.py
+  symbols_table.h
+)
+
+py_gen(options.cpp
+  make_options.py
+  options.h
+  options.cpp.in
+)
+
+py_gen(option_enum.h
+  make_option_enum.py
+  option.h
+  option_enum.h.in
+)
+
+py_gen(option_enum.cpp
+  make_option_enum.py
+  option.h
+  option_enum.cpp.in
+)
+
 #
 # Uncrustify
 #
-add_executable(uncrustify
+set(uncrustify_sources
   src/align.cpp
   src/align_stack.cpp
   src/args.cpp
@@ -182,21 +231,22 @@
   src/combine.cpp
   src/compat_posix.cpp
   src/compat_win32.cpp
-  src/defines.cpp
   src/detect.cpp
-  src/helper_for_print.cpp
+  src/enum_cleanup.cpp
   src/indent.cpp
   src/keywords.cpp
   src/lang_pawn.cpp
+  src/language_tools.cpp
   src/logger.cpp
   src/logmask.cpp
   src/md5.cpp
   src/newlines.cpp
-  src/options.cpp
+  src/option.cpp
   src/options_for_QT.cpp
   src/output.cpp
   src/parens.cpp
-  src/parse_frame.cpp
+  src/frame_list.cpp
+  src/ParseFrame.cpp
   src/punctuators.cpp
   src/semicolons.cpp
   src/sorting.cpp
@@ -208,8 +258,10 @@
   src/unc_tools.cpp
   src/unicode.cpp
   src/universalindentgui.cpp
-  src/controlPSECount.cpp
   src/width.cpp
+)
+
+set(uncrustify_headers
   src/align_stack.h
   src/args.h
   src/backup.h
@@ -217,23 +269,32 @@
   src/char_table.h
   src/ChunkStack.h
   src/chunk_list.h
-  src/helper_for_print.h
+  src/enum_cleanup.h
+  src/enum_flags.h
+  src/language_tools.h
   src/ListManager.h
   src/logger.h
   src/logmask.h
   src/log_levels.h
   src/md5.h
+  src/option.h
   src/options.h
   src/options_for_QT.h
+  src/ParseFrame.h
   src/prototypes.h
   src/punctuators.h
+  src/symbols_table.h
   src/token_enum.h
   src/uncrustify_types.h
   src/unc_ctype.h
   src/unc_text.h
   src/unc_tools.h
-  src/controlPSECount.h
-)
+  ${PROJECT_BINARY_DIR}/src/options.cpp
+  ${PROJECT_BINARY_DIR}/src/option_enum.cpp
+  ${PROJECT_BINARY_DIR}/src/option_enum.h
+)
+
+add_executable(uncrustify ${uncrustify_sources} ${uncrustify_headers})
 
 if(CMAKE_VERSION VERSION_LESS 2.8.10)
   if(CMAKE_CONFIGURATION_TYPES OR CMAKE_BUILD_TYPE)
@@ -267,6 +328,31 @@
 endif()
 
 #
+# Coverage
+#
+OPTION(ENABLE_CODECOVERAGE "Enable code coverage testing support")
+if(ENABLE_CODECOVERAGE)
+    set(CODECOVERAGE_DEPENDS uncrustify)
+    include(${CMAKE_SOURCE_DIR}/cmake/CodeCoverage.cmake)
+endif(ENABLE_CODECOVERAGE)
+
+#
+# Build command to run uncrustify on its own sources
+#
+add_custom_target(format-sources)
+foreach(source IN LISTS uncrustify_sources uncrustify_headers)
+  get_filename_component(source_name  ${source} NAME)
+  add_custom_target(format-${source_name}
+    COMMAND uncrustify
+      -c forUncrustifySources.cfg
+      -lCPP --no-backup ${source}
+    COMMENT "Formatting ${source}"
+    WORKING_DIRECTORY ${uncrustify_SOURCE_DIR}
+  )
+  add_dependencies(format-sources format-${source_name})
+endforeach()
+
+#
 # Package
 #
 set(CPACK_PACKAGE_NAME "uncrustify")

=== debian/changelog ===
uncrustify (0.68.1+dfsg1-2) unstable; urgency=medium

  * Add d/patches/fix_parallel_test.patch: Fix test failure on parallel run.

 -- Alexander GQ Gerasiov <gq@debian.org>  Mon, 10 Dec 2018 02:36:22 +0300

uncrustify (0.68.1+dfsg1-1) unstable; urgency=medium

  * New upstream version 0.68.1
  * d/control: Add python-all to Build-Depensds.
  * d/rules: Run all tests (now disabled by default by upstream).

 -- Alexander GQ Gerasiov <gq@debian.org>  Sun, 02 Dec 2018 16:19:42 +0300

uncrustify (0.67+dfsg1-1) unstable; urgency=medium

  * New upstream version 0.67
  * debian/control: Move git to salsa.
  * Add docs-remove-remote-images.patch: Remove remote images from docs.

 -- Alexander GQ Gerasiov <gq@debian.org>  Mon, 18 Jun 2018 01:13:56 +0300

## uncrustify 0.69.0+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -55,6 +55,8 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1 -fno-omit-frame-pointer -fsanitize=${ENABLE_SANITIZER}")
 endif()
 
+#set(UNCRUSTIFY_SEPARATE_TESTS "True")
+
 include_directories(
   ${PROJECT_BINARY_DIR}/src
   ${PROJECT_SOURCE_DIR}/src
@@ -126,7 +128,7 @@
 #
 
 # FIXME: the version number should be automatically integrated
-set(CURRENT_VERSION "Uncrustify-0.68_f")
+set(CURRENT_VERSION "Uncrustify-0.69.0_f")
 
 find_package(PythonInterp REQUIRED)
 option(NoGitVersionString "Do not use make_version.py and git to build a version string" OFF)
@@ -216,12 +218,40 @@
   option_enum.cpp.in
 )
 
+py_gen(../etc/uncrustify.xml
+  make_katehl.py
+  ../etc/uncrustify.xml.in
+  options.h
+  option.h
+  token_enum.h
+)
+
 #
 # Uncrustify
 #
 set(uncrustify_sources
   src/align.cpp
+  src/align_add.cpp
+  src/align_assign.cpp
+  src/align_asm_colon.cpp
+  src/align_func_params.cpp
+  src/align_func_proto.cpp
+  src/align_init_brace.cpp
+  src/align_left_shift.cpp
+  src/align_log_al.cpp
+  src/align_nl_cont.cpp
+  src/align_oc_decl_colon.cpp
+  src/align_oc_msg_spec.cpp
+  src/align_oc_msg_colons.cpp
+  src/align_preprocessor.cpp
+  src/align_same_func_call_params.cpp
   src/align_stack.cpp
+  src/align_struct_initializers.cpp
+  src/align_tab_column.cpp
+  src/align_tools.cpp
+  src/align_trailing_comments.cpp
+  src/align_typedefs.cpp
+  src/align_var_def_brace.cpp
   src/args.cpp
   src/backup.cpp
   src/braces.cpp
@@ -233,6 +263,7 @@
   src/compat_win32.cpp
   src/detect.cpp
   src/enum_cleanup.cpp
+  src/flag_parens.cpp
   src/indent.cpp
   src/keywords.cpp
   src/lang_pawn.cpp
@@ -245,6 +276,7 @@
   src/options_for_QT.cpp
   src/output.cpp
   src/parens.cpp
+  src/quick_align_again.cpp
   src/frame_list.cpp
   src/ParseFrame.cpp
   src/punctuators.cpp
@@ -254,6 +286,7 @@
   src/tokenize.cpp
   src/tokenize_cleanup.cpp
   src/uncrustify.cpp
+  src/uncrustify_types.cpp
   src/unc_text.cpp
   src/unc_tools.cpp
   src/unicode.cpp
@@ -262,7 +295,28 @@
 )
 
 set(uncrustify_headers
+  src/align.h
+  src/align_add.h
+  src/align_assign.h
+  src/align_asm_colon.h
+  src/align_func_params.h
+  src/align_func_proto.h
+  src/align_init_brace.h
+  src/align_left_shift.h
+  src/align_log_al.h
+  src/align_nl_cont.h
+  src/align_oc_decl_colon.h
+  src/align_oc_msg_colons.h
+  src/align_oc_msg_spec.h
+  src/align_preprocessor.h
+  src/align_same_func_call_params.h
   src/align_stack.h
+  src/align_struct_initializers.h
+  src/align_tab_column.h
+  src/align_tools.h
+  src/align_trailing_comments.h
+  src/align_typedefs.h
+  src/align_var_def_brace.h
   src/args.h
   src/backup.h
   src/base_types.h
@@ -271,6 +325,7 @@
   src/chunk_list.h
   src/enum_cleanup.h
   src/enum_flags.h
+  src/flag_parens.h
   src/language_tools.h
   src/ListManager.h
   src/logger.h
@@ -283,6 +338,7 @@
   src/ParseFrame.h
   src/prototypes.h
   src/punctuators.h
+  src/quick_align_again.h
   src/symbols_table.h
   src/token_enum.h
   src/uncrustify_types.h
@@ -320,6 +376,13 @@
 configure_file(man/uncrustify.1.in uncrustify.1 @ONLY)
 
 #
+# Generate uncrustify.xml (katepart highlighting file)
+#
+add_custom_target(katehl
+  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/etc/uncrustify.xml
+)
+
+#
 # Tests
 #
 if(BUILD_TESTING)

=== emscripten/CMakeLists.txt ===
--- 
+++ 
@@ -29,6 +29,7 @@
 include(CheckSymbolExists)
 include(CheckCXXSymbolExists)
 include(CheckTypeSize)
+
 
 #
 # Determine config
@@ -100,7 +101,7 @@
 if( NOT CMAKE_BUILD_TYPE )
   set( CMAKE_BUILD_TYPE Release )
 endif()
-set( FALLBACK_VERSION "Uncrustify-0.64_f" )
+set( FALLBACK_VERSION "Uncrustify-0.66.1_f" )
 
 find_package(PythonInterp REQUIRED)
 execute_process(
@@ -133,15 +134,31 @@
   COMMENT "Generating token_names.h"
 )
 
+
+#
+# Generate punctuator_table.h
+#
+add_custom_command(
+  OUTPUT "punctuator_table.h"
+  COMMAND ${PYTHON_EXECUTABLE}
+    "${unc_projdir}/scripts/punc.py"
+    "punctuator_table.h"
+  MAIN_DEPENDENCY "${unc_projdir}/src/symbols_table.h"
+  COMMENT "Generating punctuator_table.h"
+)
+
 # ------------------------------------------------------------------------------
 
 FILE(GLOB unc_infiles "${unc_projdir}/src/*.cpp")
 
-ADD_EXECUTABLE(${project_name} ${unc_infiles} ${unc_projdir}/src/token_enum.h)
+ADD_EXECUTABLE(${project_name} ${unc_infiles} ${unc_projdir}/src/token_enum.h ${unc_projdir}/src/symbols_table.h)
 
 SET(unc_compile_flags "--bind -O3")
 SET_TARGET_PROPERTIES(${project_name}
     PROPERTIES
+        CXX_STANDARD 11
+        CXX_STANDARD_REQUIRED YES
+        CXX_EXTENSIONS NO
         COMPILE_FLAGS "${unc_compile_flags}"
         LINK_FLAGS "${unc_compile_flags} \
                     -s TOTAL_MEMORY=67108864 \
@@ -150,6 +167,8 @@
                     -s MODULARIZE=1 \
                     -s EXPORT_NAME=\"'${project_name}'\" \
                     -s ERROR_ON_UNDEFINED_SYMBOLS=1 \
+                    -s 'EXTRA_EXPORTED_RUNTIME_METHODS=[\"UTF8ToString\",\"stringToUTF8\",\"lengthBytesUTF8\", \"writeAsciiToMemory\"]' \
+                    -s WASM=0\
                     --memory-init-file 0\
                     --pre-js ${CMAKE_CURRENT_LIST_DIR}/prefix_module.js \
                     --post-js ${CMAKE_CURRENT_LIST_DIR}/postfix_module.js \

=== debian/changelog ===
uncrustify (0.69.0+dfsg1-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:28:10 +0100

uncrustify (0.69.0+dfsg1-1) unstable; urgency=medium

  * New upstream version 0.69.0
  * Remove fix_parallel_test.patch: Fixed upstream.

 -- Alexander GQ Gerasiov <gq@debian.org>  Tue, 02 Jul 2019 19:00:32 +0300

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: devel
 Priority: optional
 Maintainer: Alexander GQ Gerasiov <gq@debian.org>
-Build-Depends: debhelper (>= 9), cmake, python-minimal
+Build-Depends: debhelper (>= 9), cmake, python-all
 Standards-Version: 4.1.2
 Homepage: https://github.com/uncrustify/uncrustify
-Vcs-Git: git://anonscm.debian.org/collab-maint/uncrustify.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/uncrustify.git;a=summary
+Vcs-Git: https://salsa.debian.org/debian/uncrustify.git
+Vcs-Browser: https://salsa.debian.org/debian/uncrustify
 
 Package: uncrustify
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,9 @@
 %:
 	dh $@ --parallel
 
+override_dh_auto_configure:
+	dh_auto_configure $@ -- -DUNCRUSTIFY_SEPARATE_TESTS=ON
+
 override_dh_clean:
 	dh_clean
 	rm -rf tests/results
